#include <bits/stdc++.h>

#define FOR(n, a, b) for(int n = (a); n < (b); ++n)
#define ALL(x) x.begin(), x.end()
#define pb push_back
#define st first
#define nd second

using namespace std;

typedef long long ll;
typedef pair<int, int> pint;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pint> vii;


ll t[1000042];
vector<ll> divs[1000042];

void init()
{
    for (int i=1; i<=1000000; i++)
    {
        for (int j=i; j<=1000000; j+=i)
        {
            divs[j].pb(i);
        }
    }
}

void cnt()
{
    for (int i=1; i<=1000000; i++)
    {
        t[i] += t[i-1];
        for (int j : divs[i])
        {
            ll d = abs(lower_bound(divs[i/j].begin(), divs[i/j].end(), j) - divs[i/j].begin());

            if (d > (divs[i/j].size() + 1) / 2)
                t[i] += d - (divs[i/j].size() + 1) / 2;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    init();
    cnt();

    int tt;
    cin >> tt;
    while (tt--)
    {
        ll n;
        cin >> n;
        cout << t[n] << "\n";
    }




    return 0;
}
